#include "masterui.h"
#include "pbcontrol.h"
#include <iostream>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

ifont *fnt;
MasterUI* MasterUI::mui=NULL;
PBSlider* velocitysl;
PBMenuButton* bank_chooser;
PBMenuButton* inst_chooser;

MasterUI::MasterUI(Master* master_,int* px):midivel(127){
  master=master_;
  mui=this;
  //exitprogram=exitprogram_;
}
void MasterUI::init_board(){
  int octw=ScreenWidth()/3.;
  int whitew=octw/12.;
  int wn=0;
  for(int i=0;i<4;++i){
    for( int j=0;j<12;++j){
      note nt;
      if(j==1 || j==3 || j==6 || j==8 || j==10){//black
        nt.black=true;
      }else{
        nt.black=false;
      }
      nt.x=i*octw+j*whitew;
      nt.y=20;
      nt.h=100;
      nt.w=whitew;
      nt.nmb=69+j+3+(i-2)*12;
      nt.play=false;
      vkeyboard.push_back(nt);
      ++wn;
    }
  }
  master->bank.rescanforbanks();
/*  for(int j=0;j<BANK_SIZE;++j){
    if(!master->bank.emptyslot(j))std::cerr<<'\t'<<j<<'\t'<<master->bank.getnamenumbered(j)<<std::endl;
  }*/
/*  for(int i=0;i<MAX_NUM_BANKS;++i){
    if(master->bank.banks[i].name!=NULL){
      std::cerr<<master->bank.banks[i].name<<std::endl;
      //for(int j=0;j<BANK_SIZE;++j)
      if(master->bank.banks[i].dir){
        master->bank.loadbank(master->bank.banks[i].dir);
        for(int j=0;j<BANK_SIZE;++j){
          if(!master->bank.emptyslot(j))std::cerr<<'\t'<<j<<'\t'<<master->bank.getnamenumbered(j)<<std::endl;
        }
      }
    }
  }*/
}
void MasterUI::draw_board(){
  //ClearScreen();
  FillArea(0,20,ScreenWidth(),100,WHITE);
  char str[128];
  for(std::vector<note>::iterator it=vkeyboard.begin();it<vkeyboard.end();++it){
    if((it->black && !it->play)|| (!it->black && it->play) )FillArea(it->x,20,it->w,100,BLACK);
    else DrawRect(it->x,it->y,it->w,it->h,BLACK);
    if(it->play){
      sprintf(str,"%d",it->nmb,acco_mode);
      SetFont(fnt,BLACK);
      DrawString(220,220,str);
    }
  }
  //FillArea(note,balance*ScreenWidth(),3,3,BLACK);
  PartialUpdateBW(0,0,ScreenWidth(),130);
}

int MasterUI::pitch_note(int px,int py){
  int octw=ScreenWidth()/3;
  int whitew=octw/12;
  int wn=0;
  if(py<vkeyboard[0].y || py>(vkeyboard[0].y+vkeyboard[0].h) )return 0;
  for(int i=0;i<3;++i){
    for( int j=0;j<12;++j){
      int x=i*octw+j*whitew;
      if(px>x && px <(x+whitew)){
        pthread_mutex_lock(&master->mutex);
        vkeyboard[wn].play=true;
        master->NoteOn(0,vkeyboard[wn].nmb+0*12,midivel);
        switch(acco_mode){
          case QUINT:
            vkeyboard[wn+7].play=true;
            master->NoteOn(0,vkeyboard[wn+7].nmb+0*12,midivel);
          break;
          case MAJOR:
            vkeyboard[wn+4].play=true;
            master->NoteOn(0,vkeyboard[wn+4].nmb+0*12,midivel);
            vkeyboard[wn+7].play=true;
            master->NoteOn(0,vkeyboard[wn+7].nmb+0*12,midivel);
          break;
          case MINOR:
            vkeyboard[wn+3].play=true;
            master->NoteOn(0,vkeyboard[wn+3].nmb+0*12,midivel);
            vkeyboard[wn+7].play=true;
            master->NoteOn(0,vkeyboard[wn+7].nmb+0*12,midivel);
          break;
          default:
          break;
        }
        //printf("Noteon :%d %d\n",vkeyboard[wn].nmb,wn);
        pthread_mutex_unlock(&master->mutex);
        return wn;
      }
      ++wn;
    }
  }
  return 0;
}
int MasterUI::mute_note(int px,int py){
  for(std::vector<note>::iterator it=vkeyboard.begin();it<vkeyboard.end();++it)
  if(it->play){
  it->play=false;
  pthread_mutex_lock(&master->mutex);
   master->NoteOff(0,it->nmb+0*12);
  pthread_mutex_unlock(&master->mutex);
  }
}
imenu main_menu[] = {
  {ITEM_HEADER ,0,"Menu",NULL},
  {ITEM_ACTIVE ,109,"About",NULL},
  {ITEM_ACTIVE ,110,"Help",NULL},
  {ITEM_ACTIVE ,111,"Exit",NULL},
  {0 , 0, NULL, NULL},
};
int saved_orientation;

void main_menu_handler(int itm){
  switch(itm){
    case 109:
    Message(ICON_INFORMATION,"About","NanoSync v 0.0.1\n"
    "Yury P. Fedorchenko 2011\n"
    "www.fedorchenko.net\n"
    "This program is free software distributed under\n"
    "the terms of the GNU General Public License",5000);
    break;
    case 110:
    Message(ICON_INFORMATION,"Help","NanoSync\n"
    "Use stylus to pitch note\nUpDownLeftRight - change accord mode, Back - menu",5000);
    break;
    case 111:
    CloseApp();
    break;
  }
}

void vel_cb(PBControll*o,void*par){
  MasterUI::mui->master->setPvolume((int)par);
  //printf("set vol:%d\n",MasterUI::mui->midivel);
}
void cb_select_bank(PBControll*o,void*par){
  Master* master=MasterUI::mui->master;
  printf("set bank:%d %s\n",int(par),master->bank.banks[(int)par].dir);
  if(master->bank.banks[(int)par].dir){
    master->bank.loadbank(master->bank.banks[(int)par].dir);
  }
  o->label=master->bank.banks[(int)par].name;
  o->draw(false);
}
#include <sstream>
std::vector<std::string> fill_bank(){
  std::vector<std::string> str;
  Master* master=MasterUI::mui->master;
  master->bank.rescanforbanks();
  for(int i=0;i<MAX_NUM_BANKS;++i){
    if(master->bank.banks[i].name!=NULL || i==0){
//      std::cerr<<master->bank.banks[i].name<<std::endl;
      std::stringstream ttt;
      ttt<<i<<'\t'<<master->bank.banks[i].name;
      str.push_back(ttt.str());
    }
  }
  return str;
}
std::vector<std::string> fill_instrum(){
  std::vector<std::string> str;
  Master* master=MasterUI::mui->master;
  for(int j=0;j<BANK_SIZE;++j){
    if(!master->bank.emptyslot(j))str.push_back(master->bank.getnamenumbered(j));
  }
  return str;
}
void cb_select_instrum(PBControll*o,void*par){
  Master* master=MasterUI::mui->master;
  int nmb=int(par);
  for(int j=0;j<BANK_SIZE;++j){
    if(!master->bank.emptyslot(j)){
      if(nmb==0){
        printf("select %s\n",master->bank.getnamenumbered(j));
        pthread_mutex_lock(&master->mutex);
          master->bank.loadfromslot(j,master->part[0]);
          pthread_mutex_unlock(&master->mutex);
        master->part[0]->applyparameters();
  o->label=master->bank.getnamenumbered(j);
  o->draw(false);
        return;
      }else --nmb;
    }
  }
  //MasterUI::mui->master->setPvolume((int)par);
  //printf("set vol:%d\n",MasterUI::mui->midivel);
}

int master_main_handler(int type,int par1,int par2){
  switch(type){
    case EVT_INIT:{
    //saved_orientation
    int fd = open("/sys/power/wake_lock",O_WRONLY,S_IWRITE);
    if(fd>=0){char* t="1";
	write(fd,&t,sizeof(char));
	close(fd);
	}
    SetOrientation(1);
    fnt = OpenFont(DEFAULTFONT,24,1);
    PBControll::cfont = OpenFont(DEFAULTFONT,14,1);
    

    MasterUI::mui->init_board();
    velocitysl=new PBSlider(10,150,40,150,0,127);
    velocitysl->callback(vel_cb);
    velocitysl->value(MasterUI::mui->master->Pvolume);
    bank_chooser = new PBMenuButton(60,150,150,40,"Select Bank");
    bank_chooser->callback(cb_select_bank);
    bank_chooser->menu(fill_bank);

    inst_chooser = new PBMenuButton(230,150,150,40,"Select Instr.");
    inst_chooser->callback(cb_select_instrum);
    inst_chooser->menu(fill_instrum);
    }break;
    case EVT_SHOW:
    ClearScreen();
    MasterUI::mui->draw_board();
    velocitysl->draw(true);
    bank_chooser->draw(true);
    inst_chooser->draw(true);
    PartialUpdateBW(0,0,ScreenWidth(),ScreenHeight());
    break;
    case EVT_KEYPRESS:
    if(velocitysl->handle(type,par1,par2))return 1;
    switch(par1){
      case KEY_UP:
      MasterUI::mui->acco_mode=MasterUI::SINGLE;
      break;
      case KEY_LEFT:
      MasterUI::mui->acco_mode=MasterUI::MINOR;
      break;
      case KEY_RIGHT:
      MasterUI::mui->acco_mode=MasterUI::MAJOR;
      break;
      case KEY_DOWN:
      MasterUI::mui->acco_mode=MasterUI::QUINT;
      break;
      case KEY_BACK:
      case KEY_MENU:
      OpenMenu(main_menu,0,20,20,main_menu_handler);
      return 1;
    }
    break;
    case EVT_KEYREPEAT:
      switch(par1){
      case KEY_BACK:
      case KEY_MENU:
      OpenMenu(main_menu,0,20,20,main_menu_handler);
      return 1;
      }
    break;
    case EVT_POINTERMOVE:
    break;
    case EVT_POINTERDOWN:{
    MasterUI::mui->pitch_note(par1,par2);
    //MasterUI::mui->draw_board();
    if(velocitysl->handle(type,par1,par2))return 1;
    if(bank_chooser->handle(type,par1,par2))return 1;
    if(inst_chooser->handle(type,par1,par2))return 1;
    }break;
    case EVT_POINTERUP:
    MasterUI::mui->mute_note(par1,par2);
    //MasterUI::mui->draw_board();
    if(velocitysl->handle(type,par1,par2))return 1;
    break;
    case EVT_EXIT:
    int fd = open("/sys/power/wake_unlock",O_WRONLY,S_IWRITE);
    if(fd>=0){char* t="1";
	write(fd,&t,sizeof(char));
	close(fd);
	}
    //prg_exit=true;
    break;
  }
  return 0;
}

